#include "Vram.h"
#include "Chars.h"
#include "Movable.h"
#include "Sprite.h"
#include "Sound.h"

extern byte[] MonoPatternSource, ColorPatternSource, SpritePatternSource;

byte[CharHeight * 4 * Char_End] CharPattern;


void InitVram()
{
    MakePatternMono(Char_Ascii, MonoPatternSource + Char_Ascii * CharHeight, 64, 0x07);
    MakePatternMono(Char_Logo, MonoPatternSource + Char_Logo * CharHeight, 16, 0x05);
    MakePatternMono(Char_CrackedFloor, MonoPatternSource + Char_CrackedFloor * CharHeight, 8 + 1, 0x0f);
    MakePatternMono(Char_Ladder, MonoPatternSource + Char_Ladder * CharHeight, 2, 0x0a);
    MakePatternMono(Char_Item, MonoPatternSource + Char_Item * CharHeight, 4, 0x06);
    MakePatternColor(Char_Remain, ColorPatternSource, Char_End - Char_Remain);
    MakeSpritePattern(SpritePatternSource, Pattern_End);
}


word PrintC(word vram, byte c)
{
    return Put(vram, c - ' ');
}


void Put2C(word vram, byte c)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, c);
            ++c;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}
