include "Vram.inc"
include "Segment.inc"

ext CharPattern_

CharPatternSize equ CharHeight*4

dseg
SpriteView:
    defs 10h
SpritePattern:
    defs 256

; void MakePatternMono(byte c, ptr<byte> pSource, byte count, byte color);
cseg
MakePatternMono_: public MakePatternMono_
dseg
MakePatternMono_@Param3: public MakePatternMono_@Param3
MakePatternMono_color:
	defb 0
cseg
MakePatternMono_: public MakePatternMono_
	push ax | push cx | push dx | push bx | push si | push di
		mov ah,CharPatternSize
		mul ah
		add ax,CharPattern_
		mov di,ax
		mov si,dx ; pSource
		do
            mov ch,8 ; v count
            do
                mov al,[si] | inc si
                mov bl,[MakePatternMono_color]
                mov bh,4
                do
                    xor ah,ah
                    test bl,01h
                    if nz
                        or ah,al
                    endif
                    test bl,10h
                    if nz
                        not al
                        or ah,al
                    endif
                    mov [di],ah | inc di

                    shr bl,1
                    dec bh
                while nz | wend
                dec ch
            while nz | wend
			dec cl
		while nz | wend
	pop di | pop si | pop bx | pop dx | pop cx | pop ax
ret


; void MakePatternColor(byte c, ptr<byte> pSource, byte count);
cseg
MakePatternColor_: public MakePatternColor_
	push ax | push cx | push dx | push si | push di
		mov ah,CharPatternSize
		mul ah
		add ax,CharPattern_
		mov di,ax
		mov si,dx
		do
			mov ch,CharPatternSize/2
			do
				mov ax,[si] | inc si | inc si
				mov [di],ax | inc di | inc di
				dec ch
			while nz | wend
			dec cl
		while nz | wend
	pop di | pop si | pop dx | pop cx | pop ax
ret


; void MakeSpritePattern(ptr<byte> pSource, byte count);
cseg
MakeSpritePattern_: public MakeSpritePattern_
	push ax | push cx | push dx | push bx | push si | push di
		mov si,ax
		mov cl,dl
        mov ch,1
		do
            push si
                ; push cx
                    mov di,SpritePattern
                    mov bx,128
                    do
                        mov al,[si] | inc si
                        mov dh,2
                        do
                            mov ah,al
                                mov dl,al
                                shr dl,1 | shr dl,1 | shr dl,1 | shr dl,1
                                and al,0f0h | or al,dl
                                mov [di],al | inc di
                            mov al,ah
                            shl al,1 | shl al,1 | shl al,1 | shl al,1
                            dec dh
                        while nz | wend
                        dec bx
                    while nz | wend
                ; pop cx
                mov di,SpriteView
                mov byte ptr [di],ch | inc di
                mov byte ptr [di],0ffh | inc di
                mov byte ptr [di],4 | inc di
                mov byte ptr [di],10 | inc di
                mov word ptr [di],32 | inc di | inc di
                mov word ptr [di],16 | inc di | inc di
                inc di | inc di
                mov ax,SpritePattern
                mov word ptr [di],ax | inc di | inc di
                mov ax,cs
                mov word ptr [di],ax | inc di | inc di
                mov es,ax
                mov bx,SpriteView
                mov ah,2
                int 84h
            pop si
            add si,128
            inc ch
			dec cl
		while nz | wend
	pop di | pop si | pop bx | pop dx | pop cx | pop ax
ret


; void ClearScreen();
cseg
ClearScreen_:  public ClearScreen_
	push ax | push bx | push cx | push dx | push di
        ; cli
            mov dx,0153h | mov al,44h | out dx,al
                mov ax,VramSegment0 | mov es,ax
                mov bl,4
                do
                    mov di,Vram
                    mov cx,VramRowSize*VramHeight/2
                    xor ax,ax
                    do
                        mov word ptr[es:di],ax | inc di | inc di
                    wloop
                    mov ax,es | add ah,high InterSegment | mov es,ax
                    dec bl
                while nz | wend
            mov dx,0153h | mov al,41h | out dx,al
        ; sti
    pop di | pop dx | pop cx | pop bx | pop ax
ret


; word VramAddress(byte x, byte y);
cseg
VramAddress_: public VramAddress_
    push dx
        mov dh,al
        mov al,VramWidth
        mul dl
        add ax,ax ;*2
        add ax,ax ;*4
        add ax,ax ;*8
        mov dl,dh
        xor dh,dh
        add ax,dx
    pop dx
ret


; word Put(word vram, byte c);
cseg
Put_: public Put_
	push ax | push cx | push dx| push si | push di
	    mov di,ax
		mov al,dl
        mov ah,CharPatternSize | mul ah
        add ax,CharPattern_
        mov si,ax
        cli
            mov dx,0153h | mov al,44h | out dx,al

            mov ch,CharHeight
            do
                mov ax,VramSegment0 | mov es,ax
                mov cl,4
                do
                    mov al,[si] inc si
                    mov [es:di],al
                    mov ax,es | add ah,high InterSegment | mov es,ax
                    dec cl
                while nz | wend
                add di,VramWidth
                dec ch
            while nz | wend

            mov dx,0153h | mov al,41h | out dx,al
        sti
	pop di | pop si | pop dx | pop cx | pop ax
	; add ax,VramStep
    inc ax
ret
